/*
  implementation for icecast stream audio "tap"

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Library General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */

#ifndef __RAWSTREAM_IMPL_H
#define __RAWSTREAM_IMPL_H

#include <artsflow.h>
#include <stdsynthmodule.h>
#include "rawstream.h"

using namespace std;
using namespace Arts;

namespace Noatun
{

class RawStream_impl : public RawStream_skel, public StdSynthModule
{
	public:
		RawStream_impl();
		~RawStream_impl();
		void streamInit();
		void streamStart();
		// in:  audio stream inleft,  inright;
		// out: audio stream outleft, outright;
		void calculateBlock(unsigned long samples);
		vector<long> *queuedData();
		// Is there data waiting for us?
		bool dataWaiting();
		void dataWaiting(bool);

	protected:
		// The audio buffer
		vector<long> _buffer;
};

}; // END namespace Noatun
#endif
