/*
    icecastpipe.h  -  Icecast/Shoutcast forwarder

    Copyright (c) 2004 by Stefan Gehn <metz AT gehn.net>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef _ICECASTPIPE_H
#define _ICECASTPIPE_H

#include <shout/shout.h>
#include <qobject.h>
class MP3Stream;
class QTimer;

class IcecastPipe : public QObject
{
	Q_OBJECT
	public:
		IcecastPipe(QObject *parent = 0, const char * name = 0);
		~IcecastPipe();

		void restart(int pauseSecs = 0);

	signals:
		void statusChange(bool);

	public:
		void setTitle(const QString &songtitle);

	public slots:
		void start();
		void stop();

	private:
		void applyOptions();
		bool sendTitle();
		void shoutcastError(int err);
		void reconnectOrError(int res);

	private slots:
		void slotNewData(char *data, int length);
		void slotTransmitData();
		void slotEncoderDied();

	private:
		shout_t *mShout; // our Shoutcast object
		MP3Stream *mStream; // our stream
		QByteArray mBuffer;
		QTimer *mSendTimer;
		QString mTitle;
		unsigned int mSendErrors;
		bool mFirst;
};

#endif
