/*
    mp3stream.h  -  Encodes raw artsd pcm data to mp3

    Copyright (c) 2002 by Ryan Cumming
    Copyright (c) 2004 by Stefan Gehn <metz AT gehn.net>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef _MP3STREAM_H
#define _MP3STREAM_H

#include <qobject.h>
#include <soundserver.h>

#include "arts/rawstream.h"

class KProcess;
class QTimer;

class MP3Stream : public QObject
{
	Q_OBJECT

	public:
		MP3Stream(QObject* parent = 0, const char* name = 0);
		~MP3Stream();

	signals:
		void newData(char *, int);
		void encoderDied();

	private slots:
		void start();
		void stop();
		void timeout();
		void receivedStdout(KProcess *proc, char *buffer, int buflen);
		void wroteStdin(KProcess *proc);
		void processExited(KProcess *);

	protected:
		Noatun::RawStream* mRawStream;
		int _mId;
		KProcess *_lame;
		bool _free_to_write;
		QTimer *_audioTimer;
};

#endif
