/*
    plugin.cpp  -  Floodcast plugin

    Copyright (c) 2002 by Ryan Cumming
    Copyright (c) 2004 by Stefan Gehn <metz AT gehn.net>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef FL_PLUGIN_H
#define FL_PLUGIN_H

#include <noatun/plugin.h>
#include <qobject.h>

class IcecastServer;
class Prefs;
class FloodcastStatus;
class IcecastPipe;
class KToggleAction;
class KAction;

class FloodcastPlugin : public QObject, public UserInterface
{
	Q_OBJECT
	public:
		FloodcastPlugin();
		~FloodcastPlugin();

		void init();

	private slots:
		void slotApplyConfig();
		void slotShowStatusWindow();
		void slotRefreshTitle();
		void slotEnabled(bool);

	private:
		Prefs *mPrefs;
		IcecastPipe *mPipe;
		IcecastServer *mServer;
		FloodcastStatus *mStatusWindow;
		KToggleAction *mUsePlugin;
		KAction *mStatusAction;
};

#endif
