/*
    prefs.h  -  Floodcast preferences widget

    Copyright (c) 2002 by Ryan Cumming
    Copyright (c) 2004 by Stefan Gehn <metz AT gehn.net>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef _PREFS_H_
#define _PREFS_H_

#include <noatun/pref.h>
#include <noatun/plugin.h>

class FloodcastPlugin;
class PrefsWidget;

class Prefs : public CModule
{
	Q_OBJECT
	public:
		Prefs(FloodcastPlugin *parent);
		virtual void reopen();
		virtual void save();

	private:
		PrefsWidget *mWidget;
		bool mModified;

	private slots:
		void slotModified();
		void slotModeChanged(int newMode);
		void slotFixedTracknameClicked();
		void slotBitrateTypeChanged(int newType);
		void slotForwardAutoreconnectToggled(bool val);

	signals:
		void saved();
};

#endif

